from odoo import models, fields


class AccountMove(models.Model):
    _inherit = "account.move"

    ml_number = fields.Char('Mercado Libre')
    pos_config_id = fields.Many2one('pos.config', string='Punto de Venta', compute='_compute_pos_config_id', store=True)

    def _compute_pos_config_id(self):
        PosOrder = self.env['pos.order']

        for record in self:
            pos_order_ref = record.ref
            pos_order = PosOrder.search([('name', '=', pos_order_ref)])
            if pos_order:
                record.pos_config_id = pos_order.config_id
            else:
                record.pos_config_id = False
