from odoo import models, api, fields


class PosOrder(models.Model):
    _inherit = "pos.order"

    # T5366
    ml_number = fields.Char('Ml number')

    @api.model
    def create_from_ui(self, orders, draft=False):
        self = self.with_context(ml_number=orders[0]['data'].get('ml_number'))
        res = super(PosOrder, self).create_from_ui(orders, draft)
        for order in orders:
            ml_number = order['data'].get('ml_number')
            if ml_number:
                order_id = self.browse(int(res[0]['id']))
                order_id.ml_number = ml_number
        return res

    def _prepare_invoice_vals(self):
        vals = super()._prepare_invoice_vals()
        if self.ml_number:
            vals.update({'ml_number': self.ml_number})
        else:
            ml_number = self.env.context.get('ml_number', False)
            if ml_number:
                vals.update({'ml_number': ml_number})
        return vals
