/** @odoo-module */

import { patch } from "@web/core/utils/patch";
import { PosDB } from "@point_of_sale/app/store/db";

patch(PosDB.prototype, {
    _product_search_string(product) {
        var str = product.display_name;
        if (product.barcode) {
            str += "|" + product.barcode;
        }
        if (product.default_code) {
            str += "|" + product.default_code;
        }
        if (product.description) {
            str += "|" + product.description;
        }
        if (product.description_sale) {
            str += "|" + product.description_sale;
        }
        if (product.supplier_infos && product.supplier_infos.length > 0){
            for (const supplier_info of product.supplier_infos) {
                if (supplier_info.product_code) {
                    str += "|" + supplier_info.product_code;
                }
            }
        }

        str = product.id + ":" + str.replace(/[\n:]/g, "") + "\n";
        return str;
    },

    _partner_search_string(partner) {
        var str = partner.name || "";
        str += "|" + (partner.barcode || "");
        str += "|" + (partner.address || "");
        str += "|" + (partner.phone || "").split(" ").join("");
        str += "|" + (partner.mobile || "").split(" ").join("");
        str += "|" + (partner.email || "");
        str += "|" + (partner.vat || "");
        str += "|" + (partner.parent_name || "");
        str += "|" + (partner.partner_sequence || "");
        str = "" + partner.id + ":" + str.replace(":", "").replace(/\n/g, " ") + "\n";
        return str;
    }
});
