/** @odoo-module */

import {ListController} from "@web/views/list/list_controller";

export class ButtonExportAllRecordsController extends ListController {
  setup() {
    super.setup();
    const context = this.props.context;
    this.handleLocalStorage(context);
  }

  handleLocalStorage(context) {
    if (!context?.view_id) {
      return;
    }
    if (
      context.active_model !== "sales.by.product.wizard" &&
      context.active_model !== "stock.by.location.wizard"
    )
      return;
    const searchString = "list," + context.view_id.id;

    let value = false;
    let matchingKey = null;
    for (let i = 0; i < localStorage.length; i++) {
      const key = localStorage.key(i);

      if (key.includes(searchString)) {
        value = localStorage.getItem(key);
        matchingKey = key;
      }
    }
    let key = "";
	console.log('1')
    if (!matchingKey) {
		console.log('2')
      if (context.active_model === "sales.by.product.wizard") {
		console.log('3')
        key =
          "optional_fields,sales.by.product.report," +
          searchString +
          ",a_at_sold,a_at_stock,default_code,hm_sold,hm_stock,maker_id,product_id,public_categ_id,sm_sold,sm_stock,ss_sold,ss_stock,total_sold,total_stock,uz_sold,uz_stock,wn_sold,wn_stock";
      } else {
		console.log('4')
        key =
          "optional_fields,product.product," +
          searchString +
          ",a_at_stock,categ_id,default_code,hm_stock,maker_id,name,qty_available,sm_stock,ss_stock,uz_stock,wn_stock";
      }
      localStorage.setItem(key, "");
      matchingKey = key;
      value = "";
    }

    const field_sold = context.active_model === "sales.by.product.wizard";

    let fieldsArray = value.split(",");

	console.log('start')
    if (context.hm_invisible === 1) {
      fieldsArray = fieldsArray.filter((field) => field !== "hm_stock");
      if (field_sold) {
        fieldsArray = fieldsArray.filter((field) => field !== "hm_sold");
      }
    } else if (context.hm_invisible === 0 && !fieldsArray.includes("hm_stock")) {
      fieldsArray.push("hm_stock");
      if (field_sold) {
        fieldsArray.push("hm_sold");
      }
    }

    if (context.sm_invisible === 1) {
      fieldsArray = fieldsArray.filter((field) => field !== "sm_stock");
      if (field_sold) {
        fieldsArray = fieldsArray.filter((field) => field !== "sm_sold");
      }
    } else if (context.sm_invisible === 0 && !fieldsArray.includes("sm_stock")) {
      fieldsArray.push("sm_stock");
      if (field_sold) {
        fieldsArray.push("sm_sold");
      }
    }

    if (context.ss_invisible === 1) {
      fieldsArray = fieldsArray.filter((field) => field !== "ss_stock");
      if (field_sold) {
        fieldsArray = fieldsArray.filter((field) => field !== "ss_sold");
      }
    } else if (context.ss_invisible === 0 && !fieldsArray.includes("ss_stock")) {
      fieldsArray.push("ss_stock");
      if (field_sold) {
        fieldsArray.push("ss_sold");
      }
    }

    if (context.uz_invisible === 1) {
      fieldsArray = fieldsArray.filter((field) => field !== "uz_stock");
      if (field_sold) {
        fieldsArray = fieldsArray.filter((field) => field !== "uz_sold");
      }
    } else if (context.uz_invisible === 0 && !fieldsArray.includes("uz_stock")) {
      fieldsArray.push("uz_stock");
      if (field_sold) {
        fieldsArray.push("uz_sold");
      }
    }

    if (context.wn_invisible === 1) {
      fieldsArray = fieldsArray.filter((field) => field !== "wn_stock");
      if (field_sold) {
        fieldsArray = fieldsArray.filter((field) => field !== "wn_sold");
      }
    } else if (context.wn_invisible === 0 && !fieldsArray.includes("wn_stock")) {
      fieldsArray.push("wn_stock");
      if (field_sold) {
        fieldsArray.push("wn_sold");
      }
    }

    if (context.a_at_invisible === 1) {
      fieldsArray = fieldsArray.filter((field) => field !== "a_at_stock");
      if (field_sold) {
        fieldsArray = fieldsArray.filter((field) => field !== "a_at_sold");
      }
    } else if (context.a_at_invisible === 0 && !fieldsArray.includes("a_at_stock")) {
      fieldsArray.push("a_at_stock");
      if (field_sold) {
        fieldsArray.push("a_at_sold");
      }
    }

    localStorage.setItem(matchingKey, fieldsArray.join(","));
  }

  async onDownloadAllData() {
    const context = this.props.context;
    this.handleLocalStorage(context);
    await this.downloadExport(this.defaultExportList, false, "xlsx");
  }
}
